package cz.zcu.kiv.cosi.parkoviste.pult;

import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import cz.zcu.kiv.cosi.parkoviste.IPrijeloOdjelo;
import cz.zcu.kiv.cosi.parkoviste.IZapVyp;
import cz.zcu.kiv.cosi.parkoviste.parkoviste.ParkovistePlneEvent;
import cz.zcu.kiv.cosi.parkoviste.parkoviste.ParkovisteZbyvaEvent;

public class Pult implements ApplicationListener {
	
	private IZapVyp tabule;
	private IZapVyp brana;
	private IPrijeloOdjelo statistika;
	
	private long pracovniDoba;
		
	public void setTabule(IZapVyp tabule) {
		this.tabule = tabule;
	}

	public void setBrana(IZapVyp brana) {
		this.brana = brana;
	}
	
	public void setStatistika(IPrijeloOdjelo statistika) {
		this.statistika = statistika;
	}
	
	public long getPracovniDoba() {
		return pracovniDoba;
	}

	public void setPracovniDoba(long pracovniDoba) {
		this.pracovniDoba = pracovniDoba;
	}

	@Override
	public void onApplicationEvent(ApplicationEvent event) {
	    if (event instanceof ParkovisteZbyvaEvent) {
	    	ParkovisteZbyvaEvent parkovisteZbyvaEvent = (ParkovisteZbyvaEvent) event;
	        System.out.println("(Pult) Volna mista: " + parkovisteZbyvaEvent.getVolnaMista());
	     }
	    else if (event instanceof ParkovistePlneEvent) {
	        System.out.println("(Pult) Parkoviste je plne!");
	     }	    
	}	

	public void zacatek() {
		System.out.println("Pracovni doba zacala, spoustim tabuli a branu...");
		tabule.zap();
		brana.zap();
	}
	
	public void konec() {
		System.out.println("Pracovni doba konci, vypinam tabuli a branu...");
		tabule.vyp();
		brana.vyp();
		System.out.println("Na parkovisti zustalo: " + (statistika.getPrijelo() - statistika.getOdjelo()) + " vozidel...");
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
        ApplicationContext ctx = new ClassPathXmlApplicationContext("beanDefinition.xml");
        Pult pult = (Pult) ctx.getBean("Pult");
		opakujPracovniDobu(pult);
	}

	public static void opakujPracovniDobu(Pult pult) {
		while (true) {
			pult.zacatek();
			try {
				Thread.sleep(pult.pracovniDoba);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			pult.konec();		
		}
	}
}
